VERSION 5.00
Begin VB.UserControl ScalableMultilineTextBox 
   BackColor       =   &H00FFC0C0&
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   2310
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4020
   KeyPreview      =   -1  'True
   MousePointer    =   3  'I-Beam
   ScaleHeight     =   2310
   ScaleWidth      =   4020
   Begin VB.TextBox Dummy 
      BackColor       =   &H00FFC0C0&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   15.75
         Charset         =   204
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   1545
      Left            =   1845
      MultiLine       =   -1  'True
      TabIndex        =   0
      Text            =   "ScalableMultilineTextBox.ctx":0000
      Top             =   315
      Visible         =   0   'False
      Width           =   1575
   End
End
Attribute VB_Name = "ScalableMultilineTextBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Event MouseWheel(ByVal Steps As Single, ByVal Shift As Integer)


Private Declare Function SetStretchBltMode Lib "gdi32" (ByVal hdc As Long, ByVal nStretchMode As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Private Declare Function SetCapture Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function InvalidateRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT, ByVal bErase As Long) As Long

Private Const WM_PRINT As Long = &H317
Private Const WM_PRINTCLIENT As Long = &H318

Private Const PRF_CHECKVISIBLE = &H1
Private Const PRF_NONCLIENT = &H2
Private Const PRF_CLIENT = &H4
Private Const PRF_ERASEBKGND = &H8
Private Const PRF_CHILDREN = &H10
Private Const PRF_OWNED = &H20

Private Const WM_SETFOCUS       As Long = &H7
Private Const WM_KEYFIRST       As Long = &H100&
Private Const WM_KEYLAST        As Long = &H108&
Private Const WM_MOUSEFIRST     As Long = &H200&
Private Const WM_MOUSELAST      As Long = &H209&
Private Const WM_CAPTURECHANGED As Long = &H215

Private Const WM_MOUSEMOVE          As Long = &H200
Private Const WM_LBUTTONDOWN        As Long = &H201&
Private Const WM_LBUTTONUP          As Long = &H202&
Private Const WM_RBUTTONDOWN        As Long = &H204&
Private Const WM_RBUTTONUP          As Long = &H205&
Private Const WM_MBUTTONDOWN        As Long = &H207&
Private Const WM_MBUTTONUP          As Long = &H208&
Private Const WM_MOUSEWHEEL         As Long = &H20A

Private Const MK_CONTROL            As Long = &H8
Private Const MK_SHIFT              As Long = &H4

Private m_fDesignModeTested     As Boolean
Private m_fInDesignMode         As Boolean
Private m_hBackbuffer           As Long
Private m_OrigWidth             As Single
Private m_OrigHeight            As Single
Private m_pxOrigWidth           As Long
Private m_pxOrigHeight          As Long
Private m_WheelAccumulator      As Long


Private WithEvents MsgFilter    As CUniWindowMsgFilter
Attribute MsgFilter.VB_VarHelpID = -1
Private WithEvents DummyFilter  As CUniWindowMsgFilter
Attribute DummyFilter.VB_VarHelpID = -1

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type unpacked_xy
    x As Integer
    y As Integer
End Type

Private Type UNPACKED_KD
    Keys    As Integer
    zDelta  As Integer
End Type

Private Type PACKED_DW
    dw As Long
End Type


Private Function TryCancelFilteringInDesignMode() As Boolean
    On Error Resume Next
    If Not m_fDesignModeTested Then
        m_fInDesignMode = Not Ambient.UserMode
        m_fDesignModeTested = True
    End If
    
    If m_fInDesignMode Then
        Set MsgFilter = New CUniWindowMsgFilter
        Set DummyFilter = New CUniWindowMsgFilter
    End If
    TryCancelFilteringInDesignMode = m_fInDesignMode
End Function

Private Sub TryApplyFilteringInUserMode()
    On Error Resume Next
    If Ambient.UserMode And m_fInDesignMode Then
        MsgFilter.WindowHandle = UserControl.hwnd
        DummyFilter.WindowHandle = Dummy.hwnd
        m_fInDesignMode = False
    End If
End Sub

Public Property Get OriginalWidth() As Single
    OriginalWidth = m_OrigWidth
End Property

Public Property Get OriginalHeight() As Single
    OriginalHeight = m_OrigHeight
End Property

Public Property Let OriginalWidth(ByVal nv As Single)
    If nv <> m_OrigWidth Then
        m_OrigWidth = nv
        HandleDummyResize
    End If
End Property

Public Property Let OriginalHeight(ByVal nv As Single)
    If nv <> m_OrigHeight Then
        m_OrigHeight = nv
        HandleDummyResize
    End If
End Property




Private Sub HandleDummyResize()
    Dummy.Move 0, 0, m_OrigWidth, m_OrigHeight

    m_pxOrigWidth = UserControl.ScaleX(m_OrigWidth, UserControl.ScaleMode, vbPixels)
    m_pxOrigHeight = UserControl.ScaleX(m_OrigHeight, UserControl.ScaleMode, vbPixels)

    Dim hCompatBitmap As Long
    Dim hBackbuffer   As Long
    
    hCompatBitmap = CreateCompatibleBitmap( _
        UserControl.hdc, _
        m_pxOrigWidth + 1, _
        m_pxOrigHeight + 1)
    
    If hCompatBitmap = 0 Then
        Error 7
    End If
    
    hBackbuffer = CreateCompatibleDC(UserControl.hdc)
    If hBackbuffer = 0 Then
        DeleteObject hCompatBitmap
        Error 7
    End If
    
    If SelectObject(hBackbuffer, hCompatBitmap) = 0 Then
        DeleteObject hCompatBitmap
        DeleteObject hBackbuffer
        Error 7
    End If
    
    DeleteObject hCompatBitmap
    
    If m_hBackbuffer <> 0 Then
        DeleteObject m_hBackbuffer
    End If
    m_hBackbuffer = hBackbuffer
End Sub



Private Sub DummyFilter_OnMessage(msg As Long, wParam As Long, lParam As Long, bCancel As Boolean)
    If TryCancelFilteringInDesignMode Then Exit Sub
    Select Case msg
        Case WM_RBUTTONUP
            ' This message causes display of context menu, and to let
            ' context menu show in proper location, we do NOT compensate.
        Case WM_MOUSEFIRST To WM_MOUSELAST
            ' Other mouse-related message require compensation:
            lParam = CompensateXyForScaling(lParam)
    End Select
    
    Select Case msg
        Case WM_MOUSEWHEEL
            If Ambient.UserMode Then
                HandleWheelMsg wParam, lParam
                bCancel = True
            End If
        Case WM_MOUSEMOVE
            'PostMessage UserControl.hwnd, &HF, UserControl.hdc, ByVal 0
            Dim r As RECT
            r.Bottom = 1
            r.Right = 1
            InvalidateRect UserControl.hwnd, r, 0
        Case &H215
           ' SetCapture UserControl.hwnd
    End Select
End Sub

Private Function CompensateXyForScaling(ByVal msg_lparam As Long) As Long
    Dim xy_packed   As PACKED_DW
    Dim xy_unpacked As unpacked_xy
    
    xy_packed.dw = msg_lparam
    LSet xy_unpacked = xy_packed
    xy_unpacked.x = xy_unpacked.x / (UserControl.Width / m_OrigWidth)
    xy_unpacked.y = xy_unpacked.y / (UserControl.Height / m_OrigHeight)
    LSet xy_packed = xy_unpacked
    CompensateXyForScaling = xy_packed.dw
End Function

Private Sub MsgFilter_OnMessage(msg As Long, wParam As Long, lParam As Long, bCancel As Boolean)
    If TryCancelFilteringInDesignMode Then Exit Sub
    Select Case msg
        Case WM_KEYFIRST To WM_KEYLAST
            SendMessage Dummy.hwnd, msg, wParam, ByVal lParam
        Case WM_MOUSEFIRST To WM_MOUSELAST
            PostMessage Dummy.hwnd, msg, wParam, ByVal lParam
'            UserControl_Paint
            bCancel = True
        Case WM_MOUSEWHEEL
            If Ambient.UserMode Then
                HandleWheelMsg wParam, lParam
                bCancel = True
            End If
        Case Else
           ' Debug.Print msg
    End Select
End Sub

Private Sub HandleWheelMsg(ByVal wParam As Long, ByVal lParam As Long)
    Const WHEEL_DELTA As Long = 120
    Dim packed_info As PACKED_DW: packed_info.dw = wParam
    Dim packed_xy   As PACKED_DW: packed_xy.dw = lParam
    Dim unpacked_info As UNPACKED_KD: LSet unpacked_info = packed_info
    Dim unpacked_xy   As unpacked_xy: LSet unpacked_xy = packed_xy
    
    m_WheelAccumulator = m_WheelAccumulator + unpacked_info.zDelta
    
    If Abs(m_WheelAccumulator) < WHEEL_DELTA Then Exit Sub
    
    Dim ShiftFlags As Long
    Dim nSteps As Long: nSteps = m_WheelAccumulator \ WHEEL_DELTA
    m_WheelAccumulator = m_WheelAccumulator Mod WHEEL_DELTA
    
    
    If unpacked_info.Keys And MK_CONTROL Then ShiftFlags = ShiftFlags Or vbCtrlMask
    If unpacked_info.Keys And MK_SHIFT Then ShiftFlags = ShiftFlags Or vbShiftMask
    RaiseEvent MouseWheel(nSteps, ShiftFlags)
End Sub







Private Sub UserControl_AmbientChanged(PropertyName As String)
    Select Case PropertyName
        Case "UserMode"
            If Ambient.UserMode Then
                TryApplyFilteringInUserMode
            Else
                TryCancelFilteringInDesignMode
            End If
    End Select
End Sub

Private Sub UserControl_Initialize()
    Set MsgFilter = New CUniWindowMsgFilter
    Set DummyFilter = New CUniWindowMsgFilter
    
    SetStretchBltMode UserControl.hdc, 4
    
    MsgFilter.WindowHandle = UserControl.hwnd
    DummyFilter.WindowHandle = Dummy.hwnd
End Sub

'Private Sub PostMouseUpDownMsg(ByVal bDown As Boolean, ByVal Button As Integer, ByVal Shift As Integer, ByVal x As Single, ByVal y As Single)
'    Dim msg As Long
'
'    Select Case Button
'        Case vbLeftButton:   If bDown Then msg = WM_LBUTTONDOWN Else msg = WM_LBUTTONUP
'        Case vbRightButton:  If bDown Then msg = WM_RBUTTONDOWN Else msg = WM_RBUTTONUP
'        Case vbMiddleButton: If bDown Then msg = WM_MBUTTONDOWN Else msg = WM_MBUTTONUP
'    End Select
'End Sub

Private Sub UserControl_Terminate()
    If m_hBackbuffer <> 0 Then
        DeleteObject m_hBackbuffer
        m_hBackbuffer = 0
    End If
    
    Set DummyFilter = Nothing
    Set MsgFilter = Nothing
End Sub


Private Sub UserControl_InitProperties()
    m_OrigWidth = UserControl.Width
    m_OrigHeight = UserControl.Height
    HandleDummyResize
    

End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    UserControl_Paint
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    UserControl_Paint
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    UserControl_Paint
End Sub

Private Sub UserControl_Paint()
    Call SendMessage(Dummy.hwnd, _
                     WM_PRINT, _
                     m_hBackbuffer, _
                     ByVal PRF_ERASEBKGND Or PRF_NONCLIENT Or PRF_CLIENT)
    StretchBlt UserControl.hdc, _
        0, _
        0, _
        UserControl.ScaleX(UserControl.Width, UserControl.ScaleMode, vbPixels), _
        UserControl.ScaleY(UserControl.Height, UserControl.ScaleMode, vbPixels), _
        m_hBackbuffer, _
        0, 0, _
        m_pxOrigWidth, _
        m_pxOrigHeight, _
        vbSrcCopy
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_OrigWidth = PropBag.ReadProperty("OriginalWidth", UserControl.Width)
    m_OrigHeight = PropBag.ReadProperty("OriginalHeight", UserControl.Height)
    HandleDummyResize
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "OriginalWidth", m_OrigWidth, UserControl.Width
    PropBag.WriteProperty "OriginalHeight", m_OrigHeight, UserControl.Height
End Sub


Private Sub UserControl_Resize()
    UserControl_Paint
End Sub

