VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CUniWindowMsgFilter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Event OnMessage(msg As Long, wParam As Long, lParam As Long, bCancel As Boolean)

Private m_hWnd          As Long
Private m_fOwnWindow    As Boolean
Private m_fInSinkCall   As Boolean
Private m_fNoReenter    As Boolean
Private m_pfnOriginalWp As Long

Private Const GWL_WNDPROC = -4&
Private Const GWL_USERDATA = -21&



Private Declare _
    Function IsWindow _
    Lib "user32" ( _
        ByVal hwnd As Long) As Long
    

Private Declare _
    Function CreateWindowEx _
    Lib "user32" _
    Alias "CreateWindowExA" ( _
        ByVal dwExStyle As Long, _
        ByVal lpClassName As String, _
        ByVal lpWindowName As String, _
        ByVal dwStyle As Long, _
        ByVal x As Long, ByVal y As Long, _
        ByVal nWidth As Long, ByVal nHeight As Long, _
        ByVal hWndParent As Long, _
        ByVal hMenu As Long, _
        ByVal hInstance As Long, _
        ByVal lParam As Long _
    ) As Long
    
Private Declare _
    Function GetWindowLong _
    Lib "user32" _
    Alias "GetWindowLongA" ( _
        ByVal hwnd As Long, _
        ByVal i As Long _
    ) As Long
    
Private Declare _
    Function SetWindowLong _
    Lib "user32" _
    Alias "SetWindowLongA" ( _
        ByVal hwnd As Long, _
        ByVal i As Long, _
        ByVal nv As Long _
    ) As Long
    
Private Declare _
    Function SetProp _
    Lib "user32" _
    Alias "SetPropA" ( _
        ByVal hwnd As Long, _
        ByVal lpString As String, _
        ByVal v As Long) As Long
    
Private Declare _
    Function RemoveProp _
    Lib "user32" _
    Alias "RemovePropA" ( _
        ByVal hwnd As Long, _
        ByVal lpString As String) As Long
        
Private Declare _
    Function DestroyWindow _
    Lib "user32" ( _
        ByVal hwnd As Long _
    ) As Long
    
Private Declare _
    Function CallWindowProc _
    Lib "user32" _
    Alias "CallWindowProcA" ( _
        ByVal pfn As Long, _
        ByVal hwnd As Long, _
        ByVal msg As Long, _
        ByVal wParam As Long, _
        ByVal lParam As Long _
    ) As Long

Private Declare _
    Function SetParent _
    Lib "user32" ( _
        ByVal hwnd As Long, _
        ByVal hParentWnd As Long _
    ) As Long
    
Private Const HWND_MESSAGE = -3&

Public Function WindowProc(ByVal msg&, ByVal w&, ByVal l&) As Long
    Dim bCancelDispatching As Boolean
    On Error Resume Next
    
    If Not (m_fInSinkCall And m_fNoReenter) Then
        m_fInSinkCall = True
        RaiseEvent OnMessage(msg, w, l, bCancelDispatching)
        m_fInSinkCall = False
    End If
    
    If Not bCancelDispatching And m_pfnOriginalWp <> 0 Then
        WindowProc = CallWindowProc(m_pfnOriginalWp, _
                                    m_hWnd, _
                                    msg, _
                                    w, _
                                    l)
    End If
End Function

Private Sub Class_Terminate()
    If m_hWnd <> 0 Then RemoveCurrentFiltering
End Sub

Private Sub RemoveCurrentFiltering()
    If m_fOwnWindow Then
        DestroyWindow m_hWnd
        m_fOwnWindow = False
    Else
        SetWindowLong m_hWnd, GWL_WNDPROC, m_pfnOriginalWp
        RemoveProp m_hWnd, UWMF_PROP_NAME_FILTER_OBJ
    End If
    
    m_hWnd = 0
End Sub

Public Property Get WindowHandle() As Long
    If m_hWnd = 0 Then
        '
        ' Delayed initialization approach: creating invisible message-receiving
        ' window only when object's owner requests handle if it hasn't specified
        ' its own handle before.
        '
        
        m_fOwnWindow = True
        
        m_hWnd = CreateWindowEx(0, _
            "STATIC", vbNullString, _
            0, _
            0, 0, 0, 0, _
            0, _
            0, _
            App.hInstance, _
            0)
            
        If m_hWnd = 0 Then
            Err.Raise 7, , "Failed to create own message receiving window"
        End If
        
        SetParent m_hWnd, HWND_MESSAGE
        
        Call SetWindowLong(m_hWnd, GWL_USERDATA, ObjPtr(Me))
        If ObjPtr(Me) <> GetWindowLong(m_hWnd, GWL_USERDATA) Then
            DestroyWindow m_hWnd
            Err.Raise 5, , "Failed to assign filter object reference to message window"
        End If
        
        If 0 = SetWindowLong(m_hWnd, GWL_WNDPROC, AddressOf UwmfWndProcForOwn) Then
            DestroyWindow m_hWnd
            Err.Raise 5, , "Failed to change WindowProc of new message receiving window"
        End If
    End If
    
    WindowHandle = m_hWnd
End Property

Public Property Let WindowHandle(ByVal hWndNew As Long)
    If m_hWnd <> 0 And m_hWnd = hWndNew Then Exit Property
    
    If Not CBool(IsWindow(hWndNew)) Then
        Err.Raise 5, , "Invalid window handle supplied for message filter"
    End If
    
    Dim pfnNewWindowWp As Long
    
    pfnNewWindowWp = GetWindowLong(hWndNew, GWL_WNDPROC)
    
    If SetProp(hWndNew, UWMF_PROP_NAME_FILTER_OBJ, ObjPtr(Me)) = 0 Then
        Err.Raise 7, , "Failed to assign filter object reference to specified window"
    End If
    
    If SetWindowLong(hWndNew, GWL_WNDPROC, AddressOf UwmfWndProcForArb) <> pfnNewWindowWp Then
        RemoveProp hWndNew, UWMF_PROP_NAME_FILTER_OBJ
        Err.Raise 5, , "Failed to change WindowProc of specified window"
    End If
    
    If m_hWnd <> 0 Then
        RemoveCurrentFiltering
    End If
    
    m_hWnd = hWndNew
    m_pfnOriginalWp = pfnNewWindowWp
End Property
